-- DO NOT REPRODUCE THIS CODE OR CLASS AS YOUR OWN
-- IT DAMAGES THE PLAYSTATION PORTABLE HOMEBREW COMMUNITY
-- PSPInstaller 8 by Meqsoft and JustLikeEd

dofile("INCLUDE/PSPI_FUNCTIO.LUA")
dofile("INCLUDE/PSPI_DEFAULT.LUA")
dofile("INCLUDE/PSPI_ABOUTME.LUA")
if pge.file.exists("DATABASE/FEA.LUA") then
	dofile("DATABASE/FEA.LUA")
end
init_stars()
settin_dltyp = 1
opti_dlt_text="Progress Bars"
while pge.running() do
	pge.controls.update()

-------------------------
-- SHOW STARTUP SCREEN --
-------------------------

	if mstate == 0 then
		nostars = 1
		for k = 250,0,-10 do
			pge.gfx.startdrawing()
			pge.gfx.clearscreen()
			graf_backg:activate()
			graf_backg:draweasy(0,0)
			pge.gfx.drawrect(0,0,480,272,pge.gfx.createcolor(back_red,back_gre,back_blu,100))
			pge.gfx.drawrect(0,0,480,272,pge.gfx.createcolor(0,0,0,k))
			draw_finis()
		end
		menu_title = menu_xpos-25
		menu_desc = menu_xpos+50
		menu_img = menu_xpos-86.25
		for k = 0,250,5 do
			draw_start()
			IMG_LOGO:activate()
			IMG_LOGO:draweasy(menu_img,menu_ypos-42,0,k/2)
			font_ari32:activate()
			font_ari32:print(menu_title,menu_ypos,pge.gfx.createcolor(255,255,255,k),"PSPInstaller 9")
			font_ari12:activate()
			font_ari12:print(menu_desc,menu_ypos+35,pge.gfx.createcolor(255,255,255,k),"By MeqSoft and JustLikeEd")
			menu_title = menu_title+0.5
			menu_desc = menu_desc-0.5
			menu_img = menu_img+0.125
			draw_finis()
		end
		pge.delay(2000000)
		menu_title = menu_xpos
		menu_desc = menu_xpos+25
		menu_img = menu_xpos-80
		for k = 250,0,-5 do
			draw_start()
			IMG_LOGO:activate()
			IMG_LOGO:draweasy(menu_img,menu_ypos-42,0,k/2)
			font_ari32:activate()
			font_ari32:print(menu_title,menu_ypos,pge.gfx.createcolor(255,255,255,k),"PSPInstaller 9")
			font_ari12:activate()
			font_ari12:print(menu_desc,menu_ypos+35,pge.gfx.createcolor(255,255,255,k),"By MeqSoft and JustLikeEd")
			menu_title = menu_title+0.5
			menu_desc = menu_desc-0.5
			menu_img = menu_img+0.125
			draw_finis()
		end
		pge.net.init()
		pge.utils.netinit()
		mstate = 1
	end

------------------------
-- CONNECT TO NETWORK --
------------------------

	if mstate == 1 then
		nostars = 1
		draw_start()
		pge.gfx.enddrawing()
		pge.net.init()
		nstate = pge.utils.netupdate()
		if nstate == 0 then
			online = 1
			mstate = 2
		elseif nstate == 1 then
			pge.net.shutdown()
			online = 0

			mstate = 2
		elseif nstate ~= PGE_UTILS_DIALOG_RUNNING then
			pge.net.shutdown()
			online = 0

			mstate = 2
		end
		pge.gfx.swapbuffers()
	end

-------------------------------------------------
-- BOOTUP, MENU OPTIONS AND GARBAGE COLLECTION --
-------------------------------------------------

	if mstate == 2 then
		nostars = 1
		dofile("INCLUDE/PSPI_BOOTUP.LUA")
		dofile("INCLUDE/MENU_OPTIONS.LUA")
		if not pge.file.exists("DATABASE/OFW.LUA") then
			ogl={}
			oal={}
			otl={}
			ool={}
		end
		if not pge.file.exists("DATABASE/CFW.LUA") then
			cgl={}
			cal={}
			ctl={}
			col={}
		end
		IMG_LOGO = nil
		IMG_TRAS = nil
		mstate = 10
	end

---------------
-- MAIN MENU --
---------------

	if mstate == 10 then
		nostars = 0
		draw_start()
		if pge.controls.pressed(PGE_CTRL_CROSS) then
			mstate = 11
			if menu_curre == 1 then
				feit = 1
				fstate = 20
			elseif menu_curre == 2 then
				fstate = 30
			elseif menu_curre == 3 then
				fstate = 40
			elseif menu_curre == 4 then
				fstate = 50
			elseif menu_curre == 5 then
				abme = 1
				fstate = 60
			elseif menu_curre == 6 then
				fstate = 70
			end
		end
		if menu_curre == menu_previ then
			menu_items[menu_previ].i:activate()
			menu_items[menu_previ].i:draweasy(menu_xpos-80,menu_ypos-42,0,125)
			font_ari32:activate()
			font_ari32:print(menu_xpos,menu_ypos,colo_white,menu_items[menu_curre].n)
			font_ari12:activate()
			font_ari12:print(menu_xpos+25,menu_ypos+35,pge.gfx.createcolor(255,255,255),menu_items[menu_previ].d)
		else
			menu_title = menu_xpos
			menu_desc = menu_xpos+25
			menu_img = menu_xpos-80
			skip_tran = 0
			for k = 250,0,-10 do
				draw_start()
				pge.controls.update()
				if pge.controls.pressed(PGE_CTRL_RIGHT) or pge.controls.pressed(PGE_CTRL_LEFT) then
					skip_tran = 1
					break
				end
				menu_items[menu_previ].i:activate()
				menu_items[menu_previ].i:draweasy(menu_img,menu_ypos-42,0,k/2)
				font_ari32:activate()
				font_ari32:print(menu_title,menu_ypos,pge.gfx.createcolor(255,255,255,k),menu_items[menu_previ].n)
				font_ari12:activate()
				font_ari12:print(menu_desc,menu_ypos+35,pge.gfx.createcolor(255,255,255,k),menu_items[menu_previ].d)
				menu_title = menu_title+1
				menu_desc = menu_desc-1
				menu_img = menu_img+0.25
				draw_finis()
			end
			if skip_tran == 0 then
			menu_title = menu_xpos-25
			menu_desc = menu_xpos+50
			menu_img = menu_xpos-86.25
			for k = 0,250,10 do
				draw_start()
				pge.controls.update()
				if pge.controls.pressed(PGE_CTRL_RIGHT) or pge.controls.pressed(PGE_CTRL_LEFT) then
					skip_tran = 1
					break
				end
				menu_items[menu_curre].i:activate()
				menu_items[menu_curre].i:draweasy(menu_img,menu_ypos-42,0,k/2)
				font_ari32:activate()
				font_ari32:print(menu_title,menu_ypos,pge.gfx.createcolor(255,255,255,k),menu_items[menu_curre].n)
				font_ari12:activate()
				font_ari12:print(menu_desc,menu_ypos+35,pge.gfx.createcolor(255,255,255,k),menu_items[menu_curre].d)
				menu_title = menu_title+1
				menu_desc = menu_desc-1
				menu_img = menu_img+0.25
				draw_finis()
			end
			end
			menu_previ = menu_curre
		end
		if pge.controls.pressed(PGE_CTRL_LEFT) then
			menu_curre = menu_curre-1
			if menu_curre<1 then
				menu_curre = 6
			end
		elseif pge.controls.pressed(PGE_CTRL_RIGHT) then
			menu_curre = menu_curre+1
			if menu_curre>6 then
				menu_curre = 1
			end
		end
		draw_finis()
	end

-------------------------
-- BRANCH TO NEW STATE --
-------------------------

	if mstate == 11 then
		nostars = 0
		menu_title = menu_xpos
		menu_desc = menu_xpos+25
		menu_img = menu_xpos-80
		for k = 250,0,-10 do
			draw_start()
			menu_items[menu_previ].i:activate()
			menu_items[menu_previ].i:draweasy(menu_img,menu_ypos-42,0,k/2)
			font_ari32:activate()
			font_ari32:print(menu_title,menu_ypos,pge.gfx.createcolor(255,255,255,k),menu_items[menu_previ].n)
			font_ari12:activate()
			font_ari12:print(menu_desc,menu_ypos+35,pge.gfx.createcolor(255,255,255,k),menu_items[menu_previ].d)
			menu_title = menu_title+1
			menu_desc = menu_desc-1
			menu_img = menu_img+0.25
			draw_finis()
		end
		menu_title = menu_xpos-140
		menu_desc = menu_xpos-65
		menu_shy = menu_ypos-110
		for k = 0,250,10 do
			draw_start()
			font_ari32:activate()
			font_ari32:print(menu_title,menu_shy,pge.gfx.createcolor(255,255,255,k),menu_items[menu_curre].n)
			font_ari12:activate()
			if menu_curre == 2 then
				font_ari12:print(menu_desc,menu_shy+35,pge.gfx.createcolor(255,255,255,k),"Downloads for Unhacked PSP's.")
			elseif menu_curre == 3 then
				font_ari12:print(menu_desc,menu_shy+35,pge.gfx.createcolor(255,255,255,k),"Downloads for Hacked PSP's.")
			else
				font_ari12:print(menu_desc,menu_shy+35,pge.gfx.createcolor(255,255,255,k),menu_items[menu_curre].d)
			end
			if menu_curre == 1 then
				featured_items[feit].i:activate()
				featured_items[feit].i:draweasy(5,menu_shy+50,0,k)
			elseif menu_curre == 6 then

			else
				pge.gfx.drawrect(5,menu_shy+50,470,200,pge.gfx.createcolor(255,255,255,k/2))
			end
			menu_title = menu_title+1
			menu_desc = menu_desc-1
			menu_img = menu_img+0.25
			draw_finis()
		end
		mstate = fstate
	end

-------------------------
-- RETURN TO MAIN MENU --
-------------------------

	if mstate == 12 then
		nostars = 0
		menu_title = 10
		menu_desc = 33
		menu_shy = menu_ypos-110
		for k = 250,0,-10 do
			draw_start()
			font_ari32:activate()
			font_ari32:print(menu_title,menu_shy,pge.gfx.createcolor(255,255,255,k),menu_items[menu_curre].n)
			font_ari12:activate()
			if menu_curre == 2 then
				font_ari12:print(menu_desc,menu_shy+35,pge.gfx.createcolor(255,255,255,k),"Downloads for Unhacked PSP's.")
			elseif menu_curre == 3 then
				font_ari12:print(menu_desc,menu_shy+35,pge.gfx.createcolor(255,255,255,k),"Downloads for Hacked PSP's.")
			else
				font_ari12:print(menu_desc,menu_shy+35,pge.gfx.createcolor(255,255,255,k),menu_items[menu_curre].d)
			end
			if menu_curre>1 and menu_curre<6 then
				pge.gfx.drawrect(5,menu_shy+50,470,200,pge.gfx.createcolor(255,255,255,k/2))
			elseif menu_curre == 6 then
			else
				featured_items[feit].i:activate()
				featured_items[feit].i:draweasy(5,menu_shy+50,0,k)
			end
			menu_title = menu_title+1
			menu_desc = menu_desc-1
			menu_img = menu_img+0.25
			draw_finis()
		end
		menu_title = menu_xpos-25
		menu_desc = menu_xpos+50
		menu_img = menu_xpos-86.25
		for k = 0,250,10 do
			draw_start()
			menu_items[menu_curre].i:activate()
			menu_items[menu_curre].i:draweasy(menu_img,menu_ypos-42,0,k/2)
			font_ari32:activate()
			font_ari32:print(menu_title,menu_ypos,pge.gfx.createcolor(255,255,255,k),menu_items[menu_curre].n)
			font_ari12:activate()
			font_ari12:print(menu_desc,menu_ypos+35,pge.gfx.createcolor(255,255,255,k),menu_items[menu_curre].d)
			menu_title = menu_title+1
			menu_desc = menu_desc-1
			menu_img = menu_img+0.25
			draw_finis()
		end
	mstate = 10
	end

--------------------
-- FEATURED ITEMS --
--------------------

	if mstate == 20 then
		nostars = 0
		draw_start()
		font_ari32:activate()
		font_ari32:print(menu_title,menu_shy,colo_white,menu_items[menu_curre].n)
		font_ari12:activate()
		font_ari12:print(menu_desc,menu_shy+35,colo_white,menu_items[menu_curre].d)
		featured_items[feit].i:activate()
		featured_items[feit].i:draweasy(5,menu_shy+50)
		if pge.font.measure(font_ari12, featured_items[feit].c) <155 then
			pge.gfx.drawrect(319,194,155,60,pge.gfx.createcolor(0,0,0,125))
		else
			pge.gfx.drawrect(465-font_ari12:measure("\""..featured_items[feit].c.."\""),194,font_ari12:measure("\""..featured_items[feit].c.."\"")+10,60,pge.gfx.createcolor(0,0,0,125))
		end
		font_ari12:activate()
		font_ari12:print(470-font_ari12:measure("\""..featured_items[feit].c.."\""),204,colo_white,"\""..featured_items[feit].c.."\"")
		star_start=455
		for k=1,featured_items[feit].t do
			pge.gfx.drawstar(star_start, 235, 16 ,6,   5, pge.gfx.createcolor(0,0,0))
			pge.gfx.drawstar(star_start, 235, 10 ,4, 5, colo_white)
			star_start=star_start-28
		end
		draw_finis()
		if pge.controls.pressed(PGE_CTRL_LEFT) then
			feit = feit-1
			if feit == 0 then
				feit = 3
			end
		elseif pge.controls.pressed(PGE_CTRL_RIGHT) then
			feit = feit+1
			if feit == 4 then
				feit = 1
			end
		end
		if online==1 then
			if pge.controls.pressed(PGE_CTRL_CROSS) then
				option_sele=1
				show_group=featured_items
				cur_selected=feit
				mstate = 21
			end
		end
		if pge.controls.pressed(PGE_CTRL_CIRCLE) then
			mstate = 12
		end
	end

	if mstate==21 then
		nostars = 0
		draw_start()
		font_ari32:activate()
		font_ari32:print(menu_title,menu_shy,colo_white,menu_items[menu_curre].n)
		font_ari12:activate()
		font_ari12:print(menu_desc,menu_shy+35,colo_white,menu_items[menu_curre].d)
		pge.gfx.drawrect(5,54,470,147,colo_twhit)
		pge.gfx.drawrect(5,206,232,47,colo_twhit)
		pge.gfx.drawrect(242,206,233,47,colo_twhit)
		if option_sele == 1 then
			pge.gfx.drawrect(5,206,232,47,pge.gfx.createcolor(back_red, back_gre, back_blu,125))
		elseif option_sele == 2 then
			pge.gfx.drawrect(242,206,233,47,pge.gfx.createcolor(back_red, back_gre, back_blu,125))
		end
		if font_ari32:measure(show_group[cur_selected].n) < 460 then
			font_ari32:activate()
			font_ari32:printcenter(58,colo_white,show_group[cur_selected].n)
		else
			font_ari12:activate()
			font_ari12:printcenter(66,colo_white,show_group[cur_selected].n)
		end
		font_ari12:activate()
		font_ari12:print(10,96,colo_white,wordwrap(show_group[cur_selected].d,font_ari12,460))
		sizeoffile=pge.math.floor(show_group[cur_selected].z / 1024)
		font_ari12:printcenter(185,colo_white,"This download is "..sizeoffile.." Kb ("..show_group[cur_selected].z.." bytes)")
		font_ari12:activate()
		font_ari12:print(90,224,colo_white,"Download")
		font_ari12:print(325,224,colo_white,"Screenshots")

		draw_finis()
		if pge.controls.pressed(PGE_CTRL_CROSS) then
			if option_sele==1 then
				nostars = 1
				menu_title = menu_xpos-25
				menu_desc = menu_xpos+50
				menu_img = menu_xpos-86.25
				for k = 0,250,10 do
					draw_start()
					IMG_DATA:activate()
					IMG_DATA:draweasy(menu_img,menu_ypos-42,0,k/2)
					font_ari32:activate()
					font_ari32:print(menu_title,menu_ypos,pge.gfx.createcolor(255,255,255,k),"Please Wait")
					font_ari12:activate()
					font_ari12:print(menu_desc,menu_ypos+35,pge.gfx.createcolor(255,255,255,k),"Downloading "..show_group[cur_selected].n.."...")
					menu_title = menu_title+1
					menu_desc = menu_desc-1
					menu_img = menu_img+0.25
					draw_finis()
				end
				if settin_dltyp==1 then
					cursp=0
					tpekb=0
					down_stat = "Starting"
					down_serv ="174.132.106.9"
					down_port = 80
					down_file = "~themeq/_PSPI/FEA/fe"..cur_selected.."/package.zip"
					down_save = show_group[cur_selected].f
					down_loca = pi_medi
					down_spee = 25000
					down_spec = 0
					down_timo = 10
					down_rect = 0
					down_recc = 0
					down_recp = 0
					prevms=21
				elseif settin_dltyp==2 then
					file_dir = "http://redstonetor.ch/_PSPI/FEA/fe"..cur_selected.."/package.zip"
				end
				mstate=22
			elseif option_sele==2 then
				mstate=26
			end
		end
		if pge.controls.pressed(PGE_CTRL_LEFT) then
			option_sele=1
		end
		if pge.controls.pressed(PGE_CTRL_RIGHT) then
			option_sele=2
		end
		if pge.controls.pressed(PGE_CTRL_CIRCLE) then
			mstate = 20
		end
	end

	if mstate==22 then
		nostars = 1
		if settin_dltyp == 2 then
			pge.net.getfile(file_dir,pi_medi..show_group[cur_selected].f)
			mstate = 23
		elseif settin_dltyp == 1 then
			draw_start()
			if down_stat == "Starting" then
				if pge.file.exists(down_loca .. down_save) then
					pge.file.remove(down_loca .. down_save)
				end
				socket = pge.net.socket.create()
				socketConnection = socket:connect(down_serv, down_port)
				if not socketConnection then
					error("Failed to connect to the server.")
				end
				request = "GET /" .. down_file .. " HTTP/1.1\r\nHost: " .. down_serv .. "\r\n\r\n"
				down_reqs = pge.net.socket.send(socket, request)
				down_head = ""
				while not string.find(down_head, "\r\n\r\n") do
					down_head = down_head .. socket:receive(1)
				end
				down_a, down_b, down_leng = string.find(down_head, "Content%-Length: (%d+)\r\n")
				down_a = nil
				down_b = nil
				down_rect = tonumber(down_leng)
				down_stat = "Downloading"
			elseif down_stat == "Downloading" then
				if down_safi == "" or not down_safi then
					down_safi = pge.file.open(down_loca .. down_save, PGE_FILE_CREATE + PGE_FILE_RDWR)
				end
				down_recp = down_safi:size()
				down_safi:write(socket:receive(down_spee))
				down_recc = down_safi:size()
				down_spec = down_recc - down_recp
				pge.delay(1000)
				if down_recc == down_rect then
					down_safi:close()
					pge.delay(1000000)
					down_stat = "Finishing"
				end
			elseif down_stat == "Finishing" then
				down_safi = ""
				socket:close()
				down_stat = "Complete"
			elseif down_stat == "Complete" then
				mstate = 23
			end
			if down_stat == "Downloading" and down_rect and down_recc then
				IMG_DATA:activate()
				IMG_DATA:draweasy(menu_xpos-80,menu_ypos-42,0,125)
				font_ari32:activate()
				font_ari32:print(menu_xpos,menu_ypos,colo_white,"Please Wait")
				font_ari12:activate()
				font_ari12:print(menu_xpos+25,menu_ypos+35,colo_white,"Downloading "..show_group[cur_selected].n.."...")
				curpercent = 284 / down_rect * down_recc
				actpercent = 100 / down_rect * down_recc
				curkb = pge.math.ceil(down_recc/1024)
				totkb = pge.math.ceil(down_rect/1024)
				spekb = pge.math.ceil(down_spec/1024)
				tpekb = tpekb + spekb
				curdate = os.date()
				if oldtime ~= curdate then
					cursp = tpekb
					tpekb = 0
				end
				oldtime = curdate
				pge.gfx.drawrectoutline(162,menu_ypos+50,286,8,colo_white)
				pge.gfx.drawrect(164,menu_ypos+52,curpercent,5,colo_twhit)
				font_ari12:print(168,menu_ypos+65,colo_white,pge.math.ceil(actpercent).." Percent Complete")
				font_ari12:print(168,menu_ypos+80,colo_white,"Download Speed : "..cursp.." Kbp/s")
				font_ari12:print(168,menu_ypos+95,colo_white,"Downloaded "..curkb.."Kb of "..totkb.."Kb")
			end
			draw_finis()
		end

	end

	if mstate==23 then
		nostars = 1
		menu_desc = menu_xpos+25
		menu_img = menu_xpos-80
		for k = 250,0,-10 do
			draw_start()
			IMG_DATA:activate()
			IMG_DATA:draweasy(menu_img,menu_ypos-42,0,k/2)
			font_ari32:activate()
			font_ari32:print(menu_title-1,menu_ypos,colo_white,"Please Wait")
			font_ari12:activate()
			font_ari12:print(menu_desc,menu_ypos+35,pge.gfx.createcolor(255,255,255,k),"Downloading "..show_group[cur_selected].n.."...")
			menu_desc = menu_desc-1
			menu_img = menu_img+0.25
			draw_finis()
		end
		menu_desc = menu_xpos+50
		menu_img = menu_xpos-86.25
		for k = 0,250,10 do
			draw_start()
			IMG_UNZI:activate()
			IMG_UNZI:draweasy(menu_img,menu_ypos-42,0,k/2)
			font_ari32:activate()
			font_ari32:print(menu_title-1,menu_ypos,colo_white,"Please Wait")
			font_ari12:activate()
			font_ari12:print(menu_desc,menu_ypos+35,pge.gfx.createcolor(255,255,255,k),"Installing "..show_group[cur_selected].n.."...")
			menu_desc = menu_desc-1
			menu_img = menu_img+0.25
			draw_finis()
		end
		mstate = 24
	end

	if mstate==24 then
		nostars = 1
		currentwd = pge.dir.getcwd()
		myzipfile = pge.zip.open(pi_medi..show_group[cur_selected].f)
		pge.dir.chdir(pi_medi)
		if myzipfile then
			myzipfile:extract()
			pge.zip.close(myzipfile)
			myzipfile = nil
			error_msg = show_group[cur_selected].n.." installed!"
			success=1
		else
			error_msg = "Error with package. Please try again later!"
			success=0
		end
		pge.dir.chdir(currentwd)
		menu_desc = menu_xpos+25
		menu_img = menu_xpos-80
		init_stars()
		nostars = 0
		for k = 250,0,-10 do
			draw_start()
			IMG_UNZI:activate()
			IMG_UNZI:draweasy(menu_img,menu_ypos-42,0,k/2)
			font_ari32:activate()
			font_ari32:print(menu_title-1,menu_ypos,pge.gfx.createcolor(255,255,255,k),"Please Wait")
			font_ari12:activate()
			font_ari12:print(menu_desc,menu_ypos+35,pge.gfx.createcolor(255,255,255,k),"Installing "..show_group[cur_selected].n.."...")
			menu_desc = menu_desc-1
			menu_img = menu_img+0.25
			draw_finis()
		end
		menu_desc = menu_xpos+50
		menu_img = menu_xpos-86.25
		for k = 0,250,10 do
			draw_start()
			if success==1 then
				IMG_TICK:activate()
				IMG_TICK:draweasy(menu_img,menu_ypos-42,0,k/2)
				font_ari32:activate()
				font_ari32:print(menu_title-1,menu_ypos,pge.gfx.createcolor(255,255,255,k),"Complete")
			elseif success==0 then
				IMG_CROS:activate()
				IMG_CROS:draweasy(menu_img,menu_ypos-42,0,k/2)
				font_ari32:activate()
				font_ari32:print(menu_title-1,menu_ypos,pge.gfx.createcolor(255,255,255,k),"Failed")
			end
			font_ari12:activate()
			font_ari12:print(menu_desc,menu_ypos+35,pge.gfx.createcolor(255,255,255,k),"Status: "..error_msg)
			menu_desc = menu_desc-1
			menu_img = menu_img+0.25
			draw_finis()
		end
		mstate = 25
		init_stars()
	end

	if mstate==25 then

		nostars = 0
		draw_start()
			if success==1 then
				IMG_TICK:activate()
				IMG_TICK:draweasy(menu_img,menu_ypos-42,0,125)
				font_ari32:activate()
				font_ari32:print(menu_title-1,menu_ypos,colo_white,"Complete")
			elseif success==0 then
				IMG_CROS:activate()
				IMG_CROS:draweasy(menu_img,menu_ypos-42,0,125)
				font_ari32:activate()
				font_ari32:print(menu_title-1,menu_ypos,colo_white,"Failed")
			end
			font_ari12:activate()
			font_ari12:print(menu_desc,menu_ypos+35,colo_white,"Status: "..error_msg)
			font_ari12:printcenter(200,colo_white,"Press (O) to Return or (X) to exit")
		draw_finis()
		if pge.controls.pressed(PGE_CTRL_CIRCLE) then

			mstate = 21
		end
		if pge.controls.pressed(PGE_CTRL_CROSS) then
			pge.exit()
		end
	end

	if mstate==26 then
		if featured_items[feit].s>0 then
			show_screenie = 0
			if online==1 then
				pge.net.getfile("http://redstonetor.ch/_PSPI/FEA/fe"..feit.."/SCREENSHOT"..show_screenie..".PNG","DATABASE/SCREEN.PNG")
				screen_show = pge.texture.load("DATABASE/SCREEN.PNG")
			end
			mstate = 27
		end
	end

	if mstate==27 then
		if online == 1 then
			nostars = 1
			draw_start()
			screen_show:activate()
			screen_show:draweasy(0,0)
			thisscreenie=show_screenie+1
			to_screenie = show_group[cur_selected].s-1
			pge.gfx.drawrect(5,247,45,20,pge.gfx.createcolor(0,0,0,125))
			font_ari12:activate()
			font_ari12:print(10,252,colo_white,thisscreenie.." of "..show_group[cur_selected].s)
			draw_finis()

			if pge.controls.pressed(PGE_CTRL_RIGHT) then
				if show_screenie==to_screenie then
				else
					show_screenie=show_screenie+1
					draw_start()
						screen_show:activate()
						screen_show:draweasy(0,0)
						pge.gfx.drawrect(5,247,135,20,pge.gfx.createcolor(0,0,0,125))
						font_ari12:activate()
						font_ari12:print(10,252,colo_white,thisscreenie.." of "..show_group[cur_selected].s.." Downloading...")
					draw_finis()
					pge.net.getfile("http://redstonetor.ch/_PSPI/FEA/fe"..cur_selected.."/SCREENSHOT"..show_screenie..".PNG","DATABASE/SCREEN.PNG")
					screen_show = pge.texture.load("DATABASE/SCREEN.PNG")
				end
			end

			if pge.controls.pressed(PGE_CTRL_LEFT) then
				if show_screenie==0 then
				else
					show_screenie=show_screenie-1
					draw_start()
						screen_show:activate()
						screen_show:draweasy(0,0)
						pge.gfx.drawrect(5,247,135,20,pge.gfx.createcolor(0,0,0,125))
						font_ari12:activate()
						font_ari12:print(10,252,colo_white,thisscreenie.." of "..show_group[cur_selected].s.." Downloading...")
					draw_finis()
					pge.net.getfile("http://redstonetor.ch/_PSPI/FEA/fe"..cur_selected.."/SCREENSHOT"..show_screenie..".PNG","DATABASE/SCREEN.PNG")
					screen_show = pge.texture.load("DATABASE/SCREEN.PNG")

				end
			end
		else
			draw_start()
			font_ari32:activate()
			font_ari32:print(menu_title,menu_shy,colo_white,menu_items[menu_curre].n)
			font_ari12:activate()
			font_ari12:print(menu_desc,menu_shy+35,colo_white,menu_items[menu_curre].d)
			pge.gfx.drawrect(5,54,470,199,colo_twhit)
			font_ari32:activate()
			font_ari32:printcenter(58,colo_white,"Error")
			font_ari12:activate()
			font_ari12:printcenter(96,colo_white,"You need to be connected to the internet to view screenshots")
			draw_finis()
		end
		if pge.controls.pressed(PGE_CTRL_CIRCLE) then
			mstate = 21
		end
	end
---------------
-- STOCK PSP --
---------------

	if mstate == 30 then
		nostars = 0
		draw_start()
		font_ari32:activate()
		font_ari32:print(menu_title,menu_shy,colo_white,menu_items[menu_curre].n)
		font_ari12:activate()
		font_ari12:print(menu_desc,menu_shy+35,colo_white,"Downloads for Unhacked PSP's.")
		pge.gfx.drawrect(5,menu_shy+50,470,200,colo_twhit)
		if option_cat == 1 then
			font_ari32:activate()
			font_ari32:print(200,138,colo_white,"Games")
			font_ari12:activate()
			font_ari12:printcenter(240,colo_white,"This section has "..#ogl.." items.")
			CAT_GAME:activate()
			CAT_GAME:draweasy(41,90)
		elseif option_cat == 2 then
			font_ari32:activate()
			font_ari32:print(200,138,colo_white,"Applications")
			font_ari12:activate()
			font_ari12:printcenter(240,colo_white,"This section has "..#oal.." items.")
			CAT_APPS:activate()
			CAT_APPS:draweasy(41,90)
		elseif option_cat == 3 then
			font_ari32:activate()
			font_ari32:print(200,138,colo_white,"Themes")
			font_ari12:activate()
			font_ari12:printcenter(240,colo_white,"This section has "..#otl.." items.")
			CAT_THEM:activate()
			CAT_THEM:draweasy(41,90)
		elseif option_cat == 4 then
			font_ari32:activate()
			font_ari32:print(200,122,colo_white,"Utilities and\nEmulators")
			font_ari12:activate()
			font_ari12:printcenter(240,colo_white,"This section has "..#ool.." items.")
			CAT_OTHE:activate()
			CAT_OTHE:draweasy(41,90)
		end
		if pge.controls.pressed(PGE_CTRL_CROSS) then
			if option_cat == 1 then
				show_group = ogl
			elseif option_cat == 2 then
				show_group = oal
			elseif option_cat == 3 then
				show_group = otl
			elseif option_cat == 4 then
				show_group = ool
			end
			option_catlin = 1
			option_catopt = 1
			prevms = 30
			mstate = 79
			if #show_group>0 then
				mstate=80
			end
		end
		if pge.controls.pressed(PGE_CTRL_LEFT) then
			option_cat = option_cat-1
			if option_cat<1 then
				option_cat = 4
			end
		end
		if pge.controls.pressed(PGE_CTRL_RIGHT) then
			option_cat = option_cat+1
			if option_cat>4 then
				option_cat = 1
			end
		end
		draw_finis()
		if pge.controls.pressed(PGE_CTRL_CIRCLE) then
			mstate = 12
		end
	end

----------------
-- HACKED PSP --
----------------

	if mstate == 40 then
		nostars = 0
		draw_start()
		font_ari32:activate()
		font_ari32:print(menu_title,menu_shy,colo_white,menu_items[menu_curre].n)
		font_ari12:activate()
		font_ari12:print(menu_desc,menu_shy+35,colo_white,"Downloads for Hacked PSP's.")
		pge.gfx.drawrect(5,menu_shy+50,470,200,colo_twhit)
		if option_cat == 1 then
			font_ari32:activate()
			font_ari32:print(200,138,colo_white,"Games")
			font_ari12:activate()
			font_ari12:printcenter(240,colo_white,"This section has "..#cgl.." items.")
			CAT_GAME:activate()
			CAT_GAME:draweasy(41,90)
		elseif option_cat == 2 then
			font_ari32:activate()
			font_ari32:print(200,138,colo_white,"Applications")
			font_ari12:activate()
			font_ari12:printcenter(240,colo_white,"This section has "..#cal.." items.")
			CAT_APPS:activate()
			CAT_APPS:draweasy(41,90)
		elseif option_cat == 3 then
			font_ari32:activate()
			font_ari32:print(200,138,colo_white,"Themes")
			font_ari12:activate()
			font_ari12:printcenter(240,colo_white,"This section has "..#ctl.." items.")
			CAT_THEM:activate()
			CAT_THEM:draweasy(41,90)
		elseif option_cat == 4 then
			font_ari32:activate()
			font_ari32:print(200,122,colo_white,"Utilities and\nEmulators")
			font_ari12:activate()
			font_ari12:printcenter(240,colo_white,"This section has "..#col.." items.")
			CAT_OTHE:activate()
			CAT_OTHE:draweasy(41,90)
		end
		if pge.controls.pressed(PGE_CTRL_CROSS) then
			if option_cat == 1 then
				show_group = cgl
			elseif option_cat == 2 then
				show_group = cal
			elseif option_cat == 3 then
				show_group = ctl
			elseif option_cat == 4 then
				show_group = col
			end
			option_catlin = 1
			option_catopt = 1
			prevms = 40
			mstate = 79
			if #show_group>0 then
				mstate=80
			end
		end
		if pge.controls.pressed(PGE_CTRL_LEFT) then
			option_cat = option_cat-1
			if option_cat<1 then
				option_cat = 4
			end
		end
		if pge.controls.pressed(PGE_CTRL_RIGHT) then
			option_cat = option_cat+1
			if option_cat>4 then
				option_cat = 1
			end
		end
		draw_finis()
		if pge.controls.pressed(PGE_CTRL_CIRCLE) then
			mstate = 12
		end
	end

-------------
-- OPTIONS --
-------------

	if mstate == 50 then
		old_media=settin_media
		old_dltyp=settin_dltyp
		old_backg=settin_backg
		opti_options=1
		mstate=51
	end

	if mstate == 51 then
		nostars = 0
		draw_start()
		font_ari32:activate()
		font_ari32:print(menu_title,menu_shy,colo_white,menu_items[menu_curre].n)
		font_ari12:activate()
		font_ari12:print(menu_desc,menu_shy+35,colo_white,menu_items[menu_curre].d)
		pge.gfx.drawrect(5,menu_shy+50,470,200,colo_twhit)
		if opti_options==1 then
			pge.gfx.drawrect(10,95,460,20,pge.gfx.createcolor(back_red, back_gre, back_blu, 125))
		elseif opti_options==2 then
			pge.gfx.drawrect(10,120,460,20,pge.gfx.createcolor(back_red, back_gre, back_blu, 125))
		elseif opti_options==3 then
			pge.gfx.drawrect(10,145,460,20,pge.gfx.createcolor(back_red, back_gre, back_blu, 125))
		elseif opti_options==4 then
			pge.gfx.drawrect(10,170,460,20,pge.gfx.createcolor(back_red, back_gre, back_blu, 125))
		elseif opti_options==5 then
			pge.gfx.drawrect(10,195,460,20,pge.gfx.createcolor(back_red, back_gre, back_blu, 125))
		end
		if settin_media==1 then
			pi_medi="ms0:/"
			opti_medi_text="Memory Stick Device"
		elseif settin_media==2 then
			pi_medi="ef0:/"
			opti_medi_text="PSP Go! Internal Flash (Not for Original, Slim or Brite PSP's)"
		end
		if settin_dltyp==1 then
			opti_dlt_text="Progress Bars"
		elseif settin_dltyp==2 then
			opti_dlt_text="No Progress  Bars"
		end
		if settin_backg==1 then
			opti_bac_text="Blue > Light Blue > Blue > Dark Blue > ..."
		end
		font_ari12:activate()
		font_ari12:printcenter(65,colo_white,"Change the options for PSPInstaller here. Press (O) to save.")
		font_ari12:print(15,100,colo_white,"Memory Device: "..opti_medi_text)
		font_ari12:print(15,125,colo_white,"Download Type: "..opti_dlt_text)
		font_ari12:print(15,150,colo_white,"Backgroun Colours: "..opti_bac_text)
		font_ari12:print(15,175,colo_white,"Check For Updates (Not Available)")
		font_ari12:print(15,200,colo_white,"Cancel and Return to Main Menu. ")
		draw_finis()
				if opti_options==1 then

			if pge.controls.pressed(PGE_CTRL_RIGHT) then
				settin_media=2
			elseif pge.controls.pressed(PGE_CTRL_LEFT) then
				settin_media=1
			end
		elseif opti_options==2 then

			if pge.controls.pressed(PGE_CTRL_LEFT) then
				settin_dltyp=1
			elseif pge.controls.pressed(PGE_CTRL_RIGHT) then
				settin_dltyp=2
			end
		elseif opti_options==3 then

			if pge.controls.pressed(PGE_CTRL_RIGHT) then
				settin_backg=1
			elseif pge.controls.pressed(PGE_CTRL_LEFT) then
				settin_backg=1
			end
		elseif opti_options==4 then

			-- CHECK FOR UPDATES
		elseif opti_options==5 then
				mstate=12
			end
		if pge.controls.pressed(PGE_CTRL_DOWN) then
			opti_options=opti_options+1
			if opti_options>5 then
				opti_options=1
			end
		end
		if pge.controls.pressed(PGE_CTRL_UP) then
			opti_options=opti_options-1
			if opti_options<1 then
				opti_options=5
			end
		end
		if pge.controls.pressed(PGE_CTRL_CIRCLE) then
			if pge.file.exists("INCLUDE/OPTION.LUA") then
					pge.file.remove("INCLUDE/OPTION.LUA")
			end
					OPF = pge.file.open("INCLUDE/OPTION.LUA" ,PGE_FILE_CREATE + PGE_FILE_WRONLY)
					OPF:write("settin_media="..settin_media.."\r\nsettin_dltyp="..settin_dltyp.."\r\nsettin_backg="..settin_backg)
					OPF:close()
					if settin_media==1 then
						pi_medi = "ms0:/"
					elseif settin_media==2 then
						pi_medi = "ef0:/"
					end


			mstate=12
		end
	end

--------------
-- ABOUT ME --
--------------

	if mstate == 60 then
		nostars = 0
		draw_start()
		font_ari32:activate()
		font_ari32:print(menu_title,menu_shy,colo_white,menu_items[menu_curre].n)
		font_ari12:activate()
		font_ari12:print(menu_desc,menu_shy+35,colo_white,menu_items[menu_curre].d)
		pge.gfx.drawrect(5,menu_shy+50,470,200,colo_twhit)
		font_ari12:print(10,65,colo_twhit,aboutme[abme].l)
		font_ari12:print(10,80,colo_white,aboutme[abme+1].l)
		font_ari12:print(10,95,colo_white,aboutme[abme+2].l)
		font_ari12:print(10,110,colo_white,aboutme[abme+3].l)
		font_ari12:print(10,125,colo_white,aboutme[abme+4].l)
		font_ari12:print(10,140,colo_white,aboutme[abme+5].l)
		font_ari12:print(10,155,colo_white,aboutme[abme+6].l)
		font_ari12:print(10,170,colo_white,aboutme[abme+7].l)
		font_ari12:print(10,185,colo_white,aboutme[abme+8].l)
		font_ari12:print(10,200,colo_white,aboutme[abme+9].l)
		font_ari12:print(10,215,colo_white,aboutme[abme+10].l)
		font_ari12:print(10,230,colo_twhit,aboutme[abme+11].l)
		draw_finis()
		if pge.controls.pressed(PGE_CTRL_UP) or pge.controls.held(PGE_CTRL_LEFT) then
			abme = abme-1
			if abme<1 then
				abme = 1
			end
		end
		if pge.controls.pressed(PGE_CTRL_DOWN) or pge.controls.held(PGE_CTRL_RIGHT) then
			abme = abme+1
			if abme+11>#aboutme then
				abme = #aboutme-11
			end
		end
		if pge.controls.pressed(PGE_CTRL_CIRCLE) then
			mstate = 12
		end
	end

----------
-- EXIT --
----------

	if mstate == 70 then
		nostars = 0
		draw_start()
		font_ari32:activate()
		font_ari32:print(menu_title,menu_shy,colo_white,menu_items[menu_curre].n)
		font_ari12:activate()
		font_ari12:print(menu_desc,menu_shy+35,colo_white,menu_items[menu_curre].d)
		font_ari12:printcenter(150,colo_white,"Press X again to confirm exit or O to return")
		draw_finis()
		if pge.controls.pressed(PGE_CTRL_CROSS) then
			menu_title = 10
			menu_desc = 33
			menu_shy = menu_ypos-110
			for k = 250,0,-10 do
				draw_start()
				font_ari32:activate()
				font_ari32:print(menu_title,menu_shy,pge.gfx.createcolor(255,255,255,k),menu_items[menu_curre].n)
				font_ari12:activate()
				font_ari12:print(menu_desc,menu_shy+35,pge.gfx.createcolor(255,255,255,k),menu_items[menu_curre].d)
				font_ari12:printcenter(150,colo_white,"Press X again to confirm exit or O to return")
				pge.gfx.drawrect(0,0,480,272,pge.gfx.createcolor(0,0,0,255-k))
				menu_title = menu_title+1
				menu_desc = menu_desc-1
				menu_img = menu_img+0.25
				draw_finis()
			end
			pge.exit()
		end
		if pge.controls.pressed(PGE_CTRL_CIRCLE) then
			mstate = 12
		end
	end

-----------------------------------------
-- HOMEBREW, THEME or UTILITY SELECTOR --
-----------------------------------------

	if mstate == 79 then
		nostars = 0
		draw_start()
		if prevms == 40 then
			font_ari32:activate()
			font_ari32:print(menu_title,menu_shy,colo_white,menu_items[menu_curre].n)
			font_ari12:activate()
			font_ari12:print(menu_desc,menu_shy+35,colo_white,"Downloads for Hacked PSP's.")
		elseif prevms == 30 then
			font_ari32:activate()
			font_ari32:print(menu_title,menu_shy,colo_white,menu_items[menu_curre].n)
			font_ari12:activate()
			font_ari12:print(menu_desc,menu_shy+35,colo_white,"Downloads for Unhacked PSP's.")
		end
		pge.gfx.drawrect(5,54,470,200,colo_twhit)
		font_ari32:activate()
		font_ari32:printcenter(58,colo_white,"Ooops... ")
		font_ari12:activate()
		font_ari12:printcenter(96,colo_white,"This section appears to be empty!")
		draw_finis()
		if pge.controls.pressed(PGE_CTRL_CIRCLE) then
			mstate=prevms
		end
	end


	if mstate == 80 then
		nostars = 0
		draw_start()
		if prevms == 40 then
			font_ari32:activate()
			font_ari32:print(menu_title,menu_shy,colo_white,menu_items[menu_curre].n)
			font_ari12:activate()
			font_ari12:print(menu_desc,menu_shy+35,colo_white,"Downloads for Hacked PSP's.")
		elseif prevms == 30 then
			font_ari32:activate()
			font_ari32:print(menu_title,menu_shy,colo_white,menu_items[menu_curre].n)
			font_ari12:activate()
			font_ari12:print(menu_desc,menu_shy+35,colo_white,"Downloads for Unhacked PSP's.")
		end
		pge.gfx.drawrect(5,54,470,47,colo_twhit)
		pge.gfx.drawrect(5,105,470,47,colo_twhit)
		pge.gfx.drawrect(5,156,470,47,colo_twhit)
		pge.gfx.drawrect(5,207,470,47,colo_twhit)
		if not #show_group then
			mstate=prevms
		else
		if option_catopt == 1 then
			pge.gfx.drawrect(5,54,470,47,pge.gfx.createcolor(back_red,back_gre,back_blu,125))
		end
		if option_catopt == 2 then
			pge.gfx.drawrect(5,105,470,47,pge.gfx.createcolor(back_red,back_gre,back_blu,125))
		end
		if option_catopt == 3 then
			pge.gfx.drawrect(5,156,470,47,pge.gfx.createcolor(back_red,back_gre,back_blu,125))
		end
		if option_catopt == 4 then
			pge.gfx.drawrect(5,207,470,47,pge.gfx.createcolor(back_red,back_gre,back_blu,125))
		end
		if show_group[option_catlin] then
			font_ari12:print(10,58,colo_white,option_catlin .. ". ".. show_group[option_catlin].n)
			font_ari12:print(10,76,colo_white,string.sub(string.gsub(show_group[option_catlin].d, "\r\n", " "), 1, 70) .. "...")
		end
		if show_group[option_catlin+1] then
			font_ari12:print(10,109,colo_white,option_catlin+1 .. ". ".. show_group[option_catlin+1].n)
			font_ari12:print(10,127,colo_white,string.sub(string.gsub(show_group[option_catlin+1].d, "\r\n", " "), 1, 70) .. "...")
		end
		if show_group[option_catlin+2] then
			font_ari12:print(10,160,colo_white,option_catlin+2 .. ". ".. show_group[option_catlin+2].n)
			font_ari12:print(10,178,colo_white,string.sub(string.gsub(show_group[option_catlin+2].d, "\r\n", " "), 1, 70) .. "...")
		end
		if show_group[option_catlin+3] then
			font_ari12:print(10,211,colo_white,option_catlin+3 .. ". ".. show_group[option_catlin+3].n)
			font_ari12:print(10,229,colo_white,string.sub(string.gsub(show_group[option_catlin+3].d, "\r\n", " "), 1, 70) .. "...")
		end
		cur_selected = option_catopt + option_catlin - 1
		if pge.controls.pressed(PGE_CTRL_CROSS) and #show_group>0 then
			option_sele = 1
			mstate = 81
		end
		if pge.controls.pressed(PGE_CTRL_DOWN) or pge.controls.held(PGE_CTRL_RIGHT) then
			if cur_selected == #show_group then
				else
					if option_catopt == 4 then
						option_catlin = option_catlin+1
						option_catopt = 4
						if option_catlin == #show_group+1 then
							option_catlin = #show_group
						end
					elseif option_catopt<4 then
						option_catopt = option_catopt + 1
					end
				end
			end
			if pge.controls.pressed(PGE_CTRL_UP) or pge.controls.held(PGE_CTRL_LEFT) then
				if cur_selected ~= 1 then
				end
				if option_catopt == 1 then
					option_catlin = option_catlin - 1
					option_catopt = 1
					if option_catlin <= 1 then
						option_catlin = 1
					end
				elseif option_catopt > 1 then
					option_catopt = option_catopt - 1
				end
			end
		draw_finis()
		end
		if pge.controls.pressed(PGE_CTRL_CIRCLE) then
			mstate = prevms
		end
	end

----------------------------------
-- ITEM DESCRIPTION AND OPTIONS --
----------------------------------

	if mstate == 81 then
		nostars = 0
		draw_start()
		if prevms == 40 then
			font_ari32:activate()
			font_ari32:print(menu_title,menu_shy,colo_white,menu_items[menu_curre].n)
			font_ari12:activate()
			font_ari12:print(menu_desc,menu_shy+35,colo_white,"Downloads for Hacked PSP's.")
		elseif prevms == 30 then
			font_ari32:activate()
			font_ari32:print(menu_title,menu_shy,colo_white,menu_items[menu_curre].n)
			font_ari12:activate()
			font_ari12:print(menu_desc,menu_shy+35,colo_white,"Downloads for Unhacked PSP's.")
		end
		pge.gfx.drawrect(5,54,470,147,colo_twhit)
		if font_ari32:measure(show_group[cur_selected].n) < 460 then
			font_ari32:activate()
			font_ari32:printcenter(58,colo_white,show_group[cur_selected].n)
		else
			font_ari12:activate()
			font_ari12:printcenter(66,colo_white,show_group[cur_selected].n)
		end
		pge.gfx.drawrect(5,206,153,47,colo_twhit)
		pge.gfx.drawrect(164,206,153,47,colo_twhit)
		pge.gfx.drawrect(323,206,152,47,colo_twhit)
		if option_sele == 1 then
			pge.gfx.drawrect(5,206,153,47,pge.gfx.createcolor(back_red, back_gre, back_blu,125))
		elseif option_sele == 2 then
			pge.gfx.drawrect(164,206,153,47,pge.gfx.createcolor(back_red, back_gre, back_blu,125))
		elseif option_sele == 3 then
			pge.gfx.drawrect(323,206,152,47,pge.gfx.createcolor(back_red, back_gre, back_blu,125))
		end
		font_ari12:activate()
		font_ari12:print(10,96,colo_white,wordwrap(show_group[cur_selected].d,font_ari12,460))
		sizeoffile=pge.math.floor(show_group[cur_selected].z / 1024)
		if show_group[cur_selected].e==0 then
			font_ari12:printcenter(170,colo_white,"This download has no reported issues.")
		elseif show_group[cur_selected].e==1 then
			font_ari12:printcenter(170,colo_white,"This download has 1 reported issue.")
		else
			font_ari12:printcenter(170,colo_white,"This download has "..show_group[cur_selected].e.." reported issues.")
		end
		font_ari12:printcenter(185,colo_white,"This download is "..sizeoffile.." Kb ("..show_group[cur_selected].z.." bytes)")
		font_ari12:print(50,224,colo_white,"Download")
		font_ari12:print(195,224,colo_white,"Screenshots ("..show_group[cur_selected].s..")")
		font_ari12:print(360,224,colo_white,"Report Issue")
		draw_finis()
		if pge.controls.pressed(PGE_CTRL_CROSS) then

				if option_sele == 1 then
					mstate = 82
				elseif option_sele == 2 then
					if show_group[cur_selected].s>0 then
						show_screenie = 0
						if online==1 then
						if menu_curre == 2 then
							pge.net.getfile("http://redstonetor.ch/_PSPI/OFW/screenshot.php?id="..show_group[cur_selected].i.."&s=0","DATABASE/SCREEN.PNG")
							screen_show = pge.texture.load("DATABASE/SCREEN.PNG")
						elseif menu_curre == 3 then
							pge.net.getfile("http://redstonetor.ch/_PSPI/CFW/screenshot.php?id="..show_group[cur_selected].i.."&s=0","DATABASE/SCREEN.PNG")
							screen_show = pge.texture.load("DATABASE/SCREEN.PNG")
						end
						end
						mstate = 90
					end
				elseif option_sele == 3 then
					prob_option=1
					mstate = 99
				end
		end
		if pge.controls.pressed(PGE_CTRL_LEFT) then
			option_sele = option_sele-1
			if option_sele<1 then
				option_sele = 3
			end
		end
		if pge.controls.pressed(PGE_CTRL_RIGHT) then
			option_sele = option_sele+1
			if option_sele>3 then
				option_sele = 1
			end
		end
		if pge.controls.pressed(PGE_CTRL_CIRCLE) then
			mstate = 80
		end
	end

-----------------------------------------
-- DDEFINE ITEM VIA GETFILE or SOCKETS --
-----------------------------------------

	if mstate == 82 then
		if online==0 then
					draw_start()
		if prevms == 40 then
			font_ari32:activate()
			font_ari32:print(menu_title,menu_shy,colo_white,menu_items[menu_curre].n)
			font_ari12:activate()
			font_ari12:print(menu_desc,menu_shy+35,colo_white,"Downloads for Hacked PSP's.")
		elseif prevms == 30 then
			font_ari32:activate()
			font_ari32:print(menu_title,menu_shy,colo_white,menu_items[menu_curre].n)
			font_ari12:activate()
			font_ari12:print(menu_desc,menu_shy+35,colo_white,"Downloads for Unhacked PSP's.")
		end
			pge.gfx.drawrect(5,54,470,199,colo_twhit)
			font_ari32:activate()
			font_ari32:printcenter(58,colo_white,"Error")
			font_ari12:activate()
			font_ari12:printcenter(96,colo_white,"You need to be connected to the internet to download.")
			draw_finis()
			if pge.controls.pressed(PGE_CTRL_CIRCLE) then
				mstate = 81
			end
		else
		nostars = 1
		menu_title = menu_xpos-25
		menu_desc = menu_xpos+50
		menu_img = menu_xpos-86.25
		for k = 0,250,10 do
			draw_start()
			IMG_DATA:activate()
			IMG_DATA:draweasy(menu_img,menu_ypos-42,0,k/2)
			font_ari32:activate()
			font_ari32:print(menu_title,menu_ypos,pge.gfx.createcolor(255,255,255,k),"Please Wait")
			font_ari12:activate()
			font_ari12:print(menu_desc,menu_ypos+35,pge.gfx.createcolor(255,255,255,k),"Downloading "..show_group[cur_selected].n.."...")
			menu_title = menu_title+1
			menu_desc = menu_desc-1
			menu_img = menu_img+0.25
			draw_finis()
		end
		if settin_dltyp == 1 then
			if menu_curre == 2 then
				if show_group==ogl then
					file_dir = "~themeq/_PSPI/OFW/files/approved/g/f"..show_group[cur_selected].i.."/package.zip"
				elseif show_group==oal then
					file_dir = "~themeq/_PSPI/OFW/files/approved/a/f"..show_group[cur_selected].i.."/package.zip"
				elseif show_group==otl then
					file_dir = "~themeq/_PSPI/OFW/files/approved/t/f"..show_group[cur_selected].i.."/package.zip"
				elseif show_group==ool then
					file_dir = "~themeq/_PSPI/OFW/files/approved/o/f"..show_group[cur_selected].i.."/package.zip"
				end
			end
			if menu_curre == 3 then
				if show_group==cgl then
					file_dir = "~themeq/_PSPI/CFW/files/approved/g/f"..show_group[cur_selected].i.."/package.zip"
				elseif show_group==cal then
					file_dir = "~themeq/_PSPI/CFW/files/approved/a/f"..show_group[cur_selected].i.."/package.zip"
				elseif show_group==ctl then
					file_dir = "~themeq/_PSPI/CFW/files/approved/t/f"..show_group[cur_selected].i.."/package.zip"
				elseif show_group==col then
					file_dir = "~themeq/_PSPI/CFW/files/approved/o/f"..show_group[cur_selected].i.."/package.zip"
				end
			end
			cursp=0
			tpekb=0
			down_stat = "Starting"
			down_serv ="174.132.106.9"
			down_port = 80
			down_file = file_dir
			down_save = show_group[cur_selected].f
			down_loca = pi_medi
			down_spee = 25000
			down_spec = 0
			down_timo = 10
			down_rect = 0
			down_recc = 0
			down_recp = 0
		elseif settin_dltyp == 2 then
			if menu_curre == 2 then
				file_dir = "http://redstonetor.ch/_PSPI/OFW"
			elseif menu_curre == 3 then
				file_dir = "http://redstonetor.ch/_PSPI/CFW"
			end
		end
		mstate = 83
		end
	end

------------------------------------------
-- DOWNLOAD ITEM VIA GETFILE OR SOCKETS --
------------------------------------------

	if mstate == 83 then
		nostars = 1
		if settin_dltyp == 2 then
			pge.net.getfile(file_dir.."download.php?id="..show_group[cur_selected].i,pi_medi..show_group[cur_selected].f)
			mstate = 84
		elseif settin_dltyp == 1 then
			draw_start()
			if down_stat == "Starting" then
				if pge.file.exists(down_loca .. down_save) then
					pge.file.remove(down_loca .. down_save)
				end
				socket = pge.net.socket.create()
				socketConnection = socket:connect(down_serv, down_port)
				if not socketConnection then
					error("Failed to connect to the server.")
				end
				request = "GET /" .. down_file .. " HTTP/1.1\r\nHost: " .. down_serv .. "\r\n\r\n"
				down_reqs = pge.net.socket.send(socket, request)
				down_head = ""
				while not string.find(down_head, "\r\n\r\n") do
					down_head = down_head .. socket:receive(1)
				end
				down_a, down_b, down_leng = string.find(down_head, "Content%-Length: (%d+)\r\n")
				down_a = nil
				down_b = nil
				down_rect = tonumber(down_leng)
				down_stat = "Downloading"
			elseif down_stat == "Downloading" then
				if down_safi == "" or not down_safi then
					down_safi = pge.file.open(down_loca .. down_save, PGE_FILE_CREATE + PGE_FILE_RDWR)
				end
				down_recp = down_safi:size()
				down_safi:write(socket:receive(down_spee))
				down_recc = down_safi:size()
				down_spec = down_recc - down_recp
				pge.delay(1000)
				if down_recc == down_rect then
					down_safi:close()
					pge.delay(1000000)
					down_stat = "Finishing"
				end
			elseif down_stat == "Finishing" then
				down_safi = ""
				socket:close()
				down_stat = "Complete"
			elseif down_stat == "Complete" then
				mstate = 84
			end
			if down_stat == "Downloading" and down_rect and down_recc then
				IMG_DATA:activate()
				IMG_DATA:draweasy(menu_xpos-80,menu_ypos-42,0,125)
				font_ari32:activate()
				font_ari32:print(menu_xpos,menu_ypos,colo_white,"Please Wait")
				font_ari12:activate()
				font_ari12:print(menu_xpos+25,menu_ypos+35,colo_white,"Downloading "..show_group[cur_selected].n.."...")
				curpercent = 284 / down_rect * down_recc
				actpercent = 100 / down_rect * down_recc
				curkb = pge.math.ceil(down_recc/1024)
				totkb = pge.math.ceil(down_rect/1024)
				spekb = pge.math.ceil(down_spec/1024)
				tpekb = tpekb + spekb
				curdate = os.date()
				if oldtime ~= curdate then
					cursp = tpekb
					tpekb = 0
				end
				oldtime = curdate
				pge.gfx.drawrectoutline(162,menu_ypos+50,286,8,colo_white)
				pge.gfx.drawrect(164,menu_ypos+52,curpercent,5,colo_twhit)
				font_ari12:print(168,menu_ypos+65,colo_white,pge.math.ceil(actpercent).." Percent Complete")
				font_ari12:print(168,menu_ypos+80,colo_white,"Download Speed : "..cursp.." Kbp/s")
				font_ari12:print(168,menu_ypos+95,colo_white,"Downloaded "..curkb.."Kb of "..totkb.."Kb")
			end
			draw_finis()
		end
	end

---------------------------------------------
-- TRANSITION BETWEEN DOWNLOAD AND INSTALL --
---------------------------------------------

	if mstate == 84 then
		nostars = 1
		menu_desc = menu_xpos+25
		menu_img = menu_xpos-80
		for k = 250,0,-10 do
			draw_start()
			IMG_DATA:activate()
			IMG_DATA:draweasy(menu_img,menu_ypos-42,0,k/2)
			font_ari32:activate()
			font_ari32:print(menu_title-1,menu_ypos,colo_white,"Please Wait")
			font_ari12:activate()
			font_ari12:print(menu_desc,menu_ypos+35,pge.gfx.createcolor(255,255,255,k),"Downloading "..show_group[cur_selected].n.."...")
			menu_desc = menu_desc-1
			menu_img = menu_img+0.25
			draw_finis()
		end
		menu_desc = menu_xpos+50
		menu_img = menu_xpos-86.25
		for k = 0,250,10 do
			draw_start()
			IMG_UNZI:activate()
			IMG_UNZI:draweasy(menu_img,menu_ypos-42,0,k/2)
			font_ari32:activate()
			font_ari32:print(menu_title-1,menu_ypos,colo_white,"Please Wait")
			font_ari12:activate()
			font_ari12:print(menu_desc,menu_ypos+35,pge.gfx.createcolor(255,255,255,k),"Installing "..show_group[cur_selected].n.."...")
			menu_desc = menu_desc-1
			menu_img = menu_img+0.25
			draw_finis()
		end
		mstate = 85
	end

------------------
-- INSTALL ITEM --
------------------

	if mstate == 85 then
		nostars = 1
		currentwd = pge.dir.getcwd()
		myzipfile = pge.zip.open(pi_medi..show_group[cur_selected].f)
		pge.dir.chdir(pi_medi)
		if myzipfile then
			myzipfile:extract()
			pge.zip.close(myzipfile)
			myzipfile = nil
			error_msg = show_group[cur_selected].n.." installed!"
			success=1
		else
			error_msg = "Error with package. Please try again later!\n\nPSPInstaller may not download any more files until restart."
			success=0
		end
		pge.dir.chdir(currentwd)
		menu_desc = menu_xpos+25
		menu_img = menu_xpos-80
		init_stars()
		nostars = 0
		for k = 250,0,-10 do
			draw_start()
			IMG_UNZI:activate()
			IMG_UNZI:draweasy(menu_img,menu_ypos-42,0,k/2)
			font_ari32:activate()
			font_ari32:print(menu_title-1,menu_ypos,pge.gfx.createcolor(255,255,255,k),"Please Wait")
			font_ari12:activate()
			font_ari12:print(menu_desc,menu_ypos+35,pge.gfx.createcolor(255,255,255,k),"Installing "..show_group[cur_selected].n.."...")
			menu_desc = menu_desc-1
			menu_img = menu_img+0.25
			draw_finis()
		end
		menu_desc = menu_xpos+50
		menu_img = menu_xpos-86.25
		for k = 0,250,10 do
			draw_start()
			if success==1 then
				IMG_TICK:activate()
				IMG_TICK:draweasy(menu_img,menu_ypos-42,0,k/2)
				font_ari32:activate()
				font_ari32:print(menu_title-1,menu_ypos,pge.gfx.createcolor(255,255,255,k),"Complete")
			elseif success==0 then
				IMG_CROS:activate()
				IMG_CROS:draweasy(menu_img,menu_ypos-42,0,k/2)
				font_ari32:activate()
				font_ari32:print(menu_title-1,menu_ypos,pge.gfx.createcolor(255,255,255,k),"Failed")
			end
			font_ari12:activate()
			font_ari12:print(menu_desc,menu_ypos+35,pge.gfx.createcolor(255,255,255,k),"Status: "..error_msg)
			menu_desc = menu_desc-1
			menu_img = menu_img+0.25
			draw_finis()
		end
		mstate = 86
		init_stars()
	end

---------------------------
-- INSTALLATION COMPLETE --
---------------------------

	if mstate == 86 then
		nostars = 0
		draw_start()
			if success==1 then
				IMG_TICK:activate()
				IMG_TICK:draweasy(menu_img,menu_ypos-42,0,125)
				font_ari32:activate()
				font_ari32:print(menu_title-1,menu_ypos,colo_white,"Complete")
			elseif success==0 then
				IMG_CROS:activate()
				IMG_CROS:draweasy(menu_img,menu_ypos-42,0,125)
				font_ari32:activate()
				font_ari32:print(menu_title-1,menu_ypos,colo_white,"Failed")
			end
			font_ari12:activate()
			font_ari12:print(menu_desc,menu_ypos+35,colo_white,"Status: "..error_msg)
			font_ari12:printcenter(200,colo_white,"Press (O) to Return or (X) to exit")
		draw_finis()
		if pge.controls.pressed(PGE_CTRL_CIRCLE) then
			mstate = 81
		end
		if pge.controls.pressed(PGE_CTRL_CROSS) then
			pge.exit()
		end
	end

----------------------
-- SHOW SCREENSHOTS --
----------------------

	if mstate == 90 then
		if online == 1 then
			nostars = 1
			draw_start()
			screen_show:activate()
			screen_show:draweasy(0,0)
			thisscreenie=show_screenie+1
			to_screenie = show_group[cur_selected].s-1
			pge.gfx.drawrect(5,247,45,20,pge.gfx.createcolor(0,0,0,125))
			font_ari12:activate()
			font_ari12:print(10,252,colo_white,thisscreenie.." of "..show_group[cur_selected].s)
			draw_finis()

			if pge.controls.pressed(PGE_CTRL_RIGHT) then
				if show_screenie==to_screenie then
				else
					show_screenie=show_screenie+1
					draw_start()
						screen_show:activate()
						screen_show:draweasy(0,0)
						pge.gfx.drawrect(5,247,135,20,pge.gfx.createcolor(0,0,0,125))
						font_ari12:activate()
						font_ari12:print(10,252,colo_white,thisscreenie.." of "..show_group[cur_selected].s.." Downloading...")
					draw_finis()
					if menu_curre == 2 then
						pge.net.getfile("http://redstonetor.ch/_PSPI/OFW/screenshot.php?id="..show_group[cur_selected].i.."&s="..show_screenie,"DATABASE/SCREEN.PNG")
						screen_show = pge.texture.load("DATABASE/SCREEN.PNG")
					elseif menu_curre == 3 then
						pge.net.getfile("http://redstonetor.ch/_PSPI/CFW/screenshot.php?id="..show_group[cur_selected].i.."&s="..show_screenie,"DATABASE/SCREEN.PNG")
						screen_show = pge.texture.load("DATABASE/SCREEN.PNG")
					end
				end
			end

			if pge.controls.pressed(PGE_CTRL_LEFT) then
				if show_screenie==0 then
				else
					show_screenie=show_screenie-1
					draw_start()
						screen_show:activate()
						screen_show:draweasy(0,0)
						pge.gfx.drawrect(5,247,135,20,pge.gfx.createcolor(0,0,0,125))
						font_ari12:activate()
						font_ari12:print(10,252,colo_white,thisscreenie.." of "..show_group[cur_selected].s.." Downloading...")
					draw_finis()
					if menu_curre == 2 then
						pge.net.getfile("http://redstonetor.ch/_PSPI/OFW/screenshot.php?id="..show_group[cur_selected].i.."&s="..show_screenie,"DATABASE/SCREEN.PNG")
						screen_show = pge.texture.load("DATABASE/SCREEN.PNG")
					elseif menu_curre == 3 then
						pge.net.getfile("http://redstonetor.ch/_PSPI/CFW/screenshot.php?id="..show_group[cur_selected].i.."&s="..show_screenie,"DATABASE/SCREEN.PNG")
						screen_show = pge.texture.load("DATABASE/SCREEN.PNG")
					end
				end
			end
		else
			draw_start()
		if prevms == 40 then
			font_ari32:activate()
			font_ari32:print(menu_title,menu_shy,colo_white,menu_items[menu_curre].n)
			font_ari12:activate()
			font_ari12:print(menu_desc,menu_shy+35,colo_white,"Downloads for Hacked PSP's.")
		elseif prevms == 30 then
			font_ari32:activate()
			font_ari32:print(menu_title,menu_shy,colo_white,menu_items[menu_curre].n)
			font_ari12:activate()
			font_ari12:print(menu_desc,menu_shy+35,colo_white,"Downloads for Unhacked PSP's.")
		end
			pge.gfx.drawrect(5,54,470,199,colo_twhit)
			font_ari32:activate()
			font_ari32:printcenter(58,colo_white,"Error")
			font_ari12:activate()
			font_ari12:printcenter(96,colo_white,"You need to be connected to the internet to view screenshots")
			draw_finis()
		end
		if pge.controls.pressed(PGE_CTRL_CIRCLE) then
			collectgarbage("collect")
			mstate = 81
		end
	end

------------------
-- REPORT ISSUE --
------------------

	if mstate == 99 then
		nostars=0
		draw_start()
		if prevms == 40 then
			font_ari32:activate()
			font_ari32:print(menu_title,menu_shy,colo_white,menu_items[menu_curre].n)
			font_ari12:activate()
			font_ari12:print(menu_desc,menu_shy+35,colo_white,"Downloads for Hacked PSP's.")
		elseif prevms == 30 then
			font_ari32:activate()
			font_ari32:print(menu_title,menu_shy,colo_white,menu_items[menu_curre].n)
			font_ari12:activate()
			font_ari12:print(menu_desc,menu_shy+35,colo_white,"Downloads for Unhacked PSP's.")
		end
		pge.gfx.drawrect(5,menu_shy+50,470,199,colo_twhit)
		if prob_option==1 then
			pge.gfx.drawrect(10,95,460,20,pge.gfx.createcolor(back_red, back_gre, back_blu, 125))
		elseif prob_option==2 then
			pge.gfx.drawrect(10,120,460,20,pge.gfx.createcolor(back_red, back_gre, back_blu, 125))
		elseif prob_option==3 then
			pge.gfx.drawrect(10,145,460,20,pge.gfx.createcolor(back_red, back_gre, back_blu, 125))
		elseif prob_option==4 then
			pge.gfx.drawrect(10,170,460,20,pge.gfx.createcolor(back_red, back_gre, back_blu, 125))
		elseif prob_option==5 then
			pge.gfx.drawrect(10,195,460,20,pge.gfx.createcolor(back_red, back_gre, back_blu, 125))
		end
		font_ari12:activate()
		font_ari12:printcenter(65,colo_white,"Please select from the following issues or press (O) to return")
		font_ari12:printcenter(100,colo_white,"Homebrew doesn't run correctly/at all")
		font_ari12:printcenter(125,colo_white,"Homebrew not as described")
		font_ari12:printcenter(150,colo_white,"Homebrew damages PSP")
		font_ari12:printcenter(175,colo_white,"Homebrew doesn't install correctly")
		font_ari12:printcenter(200,colo_white,"Homebrew causes other issues")

		draw_finis()
		if pge.controls.pressed(PGE_CTRL_UP) then
			prob_option=prob_option-1
			if prob_option<1 then
				prob_option=5
			end
		end
		if pge.controls.pressed(PGE_CTRL_DOWN) then
			prob_option=prob_option+1
			if prob_option>5 then
				prob_option=1
			end
		end
		if pge.controls.pressed(PGE_CTRL_CIRCLE) then
			mstate = 81
		end
		if pge.controls.pressed(PGE_CTRL_CROSS) then
			mstate=100
		end


	end

	if mstate==100 then
		if online==1 then
			if prob_option==1 then
				error_text="Homebrew%20doesnt%20run%20correctly%20or%20at%20all"
			elseif prob_option==2 then
				error_text="Homebrew%20not%20as%20described"
			elseif prob_option==3 then
				error_text="Homebrew%20damages%20PSP"
			elseif prob_option==4 then
				error_text="Homebrew%20doesnt%20install%20correctly"
			elseif prob_option==5 then
				error_text="Homebrew%20causes%20other%20issues"
			end
			draw_start()
			if prevms == 40 then
				font_ari32:activate()
				font_ari32:print(menu_title,menu_shy,colo_white,menu_items[menu_curre].n)
				font_ari12:activate()
				font_ari12:print(menu_desc,menu_shy+35,colo_white,"Downloads for Hacked PSP's.")
				pge.net.getfile("http://redstonetor.ch/_PSPI/CFW/report.php?id="..show_group[cur_selected].i.."&title="..error_text.."&desc=0","DATABASE/JUNK.TMP")
			elseif prevms == 30 then
				font_ari32:activate()
				font_ari32:print(menu_title,menu_shy,colo_white,menu_items[menu_curre].n)
				font_ari12:activate()
				font_ari12:print(menu_desc,menu_shy+35,colo_white,"Downloads for Unhacked PSP's.")
				pge.net.getfile("http://redstonetor.ch/_PSPI/OFW/report.php?id="..show_group[cur_selected].i.."&title="..error_text.."&desc=0","DATABASE/JUNK.TMP")
			end
			mstate=101
		else
			draw_start()
			if prevms == 40 then
				font_ari32:activate()
				font_ari32:print(menu_title,menu_shy,colo_white,menu_items[menu_curre].n)
				font_ari12:activate()
				font_ari12:print(menu_desc,menu_shy+35,colo_white,"Downloads for Hacked PSP's.")
			elseif prevms == 30 then
				font_ari32:activate()
				font_ari32:print(menu_title,menu_shy,colo_white,menu_items[menu_curre].n)
				font_ari12:activate()
				font_ari12:print(menu_desc,menu_shy+35,colo_white,"Downloads for Unhacked PSP's.")
			end
				pge.gfx.drawrect(5,54,470,199,colo_twhit)
				font_ari32:activate()
				font_ari32:printcenter(58,colo_white,"Error")
				font_ari12:activate()
				font_ari12:printcenter(96,colo_white,"You need to be connected to the internet to send error reports.")
				draw_finis()

			if pge.controls.pressed(PGE_CTRL_CIRCLE) then
				mstate = 99
			end
		end
	end
	if mstate==101 then
		draw_start()
		if prevms == 40 then
			font_ari32:activate()
			font_ari32:print(menu_title,menu_shy,colo_white,menu_items[menu_curre].n)
			font_ari12:activate()
			font_ari12:print(menu_desc,menu_shy+35,colo_white,"Downloads for Hacked PSP's.")
		elseif prevms == 30 then
			font_ari32:activate()
			font_ari32:print(menu_title,menu_shy,colo_white,menu_items[menu_curre].n)
			font_ari12:activate()
			font_ari12:print(menu_desc,menu_shy+35,colo_white,"Downloads for Unhacked PSP's.")
		end
		pge.gfx.drawrect(5,54,470,199,colo_twhit)
		font_ari32:activate()
		font_ari32:printcenter(58,colo_white,"Report")
		font_ari12:activate()
		font_ari12:printcenter(96,colo_white,"Thank you for telling us about this issue. It will be looked into.")
		draw_finis()
		if pge.controls.pressed(PGE_CTRL_CIRCLE) then
			mstate = 81
		end
	end
end
